#pragma once

#include <GL/glew.h>
#include <GLFW/glfw3.h>
#include <glm/glm.hpp>
#include <glm/gtc/matrix_transform.hpp>
#include <glm/gtc/type_ptr.hpp>

#include <iostream>

#include "Program.h"
#include "Framebuffer.h"
#include "Utilities.h"

class OpenGLWindow
{
public:

	OpenGLWindow();
	~OpenGLWindow();

	bool InitWindow();

	void InitScene();

	void MainLoop();

	static OpenGLWindow* activeWindow;

	void setWindowResolution(glm::vec2 resolution);

private:

	GLFWwindow* _window;

	Program textureProgram;
	Program fullscreenQuadProgram;

	GLuint boxVAO;
	GLenum boxVAOPrimitive;
	unsigned int boxVAOVertexCount;

	GLuint fullscreenQuadVAO;
	GLenum fullscreenQuadPrimitive;
	unsigned int fullscreenQuadVAOVertexCount;

	GLuint boxTexture;

	void processInput();

	glm::vec2 windowResolution;
	float fieldOfView;

	glm::mat4 projectionMatrix;
	glm::mat4 cameraMatrix;
	glm::mat4 modelMatrix;

	glm::vec3 cameraPosition;
	glm::vec3 cameraDirection;
	glm::vec3 cameraUp;
	float cameraSpeed;

	Framebuffer framebuffer;
	glm::vec2 framebufferSize;
};
