#version 330 core

layout (location = 0) in vec3 attrPosition;
layout (location = 1) in vec2 attrTexCoord;

out vec2 vTexCoord;

uniform mat4 uProjectionMatrix;
uniform mat4 uCameraMatrix;
uniform mat4 uModelMatrix;
uniform sampler2D uTexture;

void main()
{
    vTexCoord = attrTexCoord;

    gl_Position = uProjectionMatrix * uCameraMatrix * uModelMatrix * vec4(attrPosition, 1.0);
}